﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Web;

namespace WebApplication1
{
    public class FilterStream : Stream
    {
        private readonly Stream _orginalStream;
        private readonly Encoding _encoding;

        public FilterStream(Stream originalStream, Encoding encoding)
        {
            _orginalStream = originalStream;
            _encoding = encoding;
        }

        public override bool CanRead => _orginalStream.CanRead;

        public override bool CanSeek => _orginalStream.CanSeek;

        public override bool CanWrite => _orginalStream.CanWrite;

        public override long Length => _orginalStream.Length;

        public override long Position { get => _orginalStream.Position; set => _orginalStream.Position = value; }

        public override void Flush()
        {
            _orginalStream.Flush();
        }

        public override int Read(byte[] buffer, int offset, int count)
        {
            return _orginalStream.Read(buffer, offset, count);
        }

        public override long Seek(long offset, SeekOrigin origin)
        {
            return _orginalStream.Seek(offset, origin);
        }

        public override void SetLength(long value)
        {
            _orginalStream.SetLength(value);
        }

        public override void Write(byte[] buffer, int offset, int count)
        {
            _orginalStream.Write(buffer, offset, count);
        }

        public override async Task WriteAsync(byte[] buffer, int offset, int count, CancellationToken cancellationToken)
        {
            await _orginalStream.WriteAsync(buffer, offset, count, cancellationToken);

            //byte[] buf = _encoding.GetBytes("TEST IS GOOD2");
            //await _orginalStream.WriteAsync(buf, 0, buf.Length, cancellationToken);
        }
    }
}